#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <netdb.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>

#include <arpa/inet.h>
#include <arpa/nameser.h>

#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/in_systm.h>

#ifdef SERVER
extern struct sockaddr_in client;
void sendfatal(char *, ...);
#endif 

u_long resolv(char *host) {

struct in_addr i;
struct hostent *h;

	if ((i.s_addr = inet_addr(host)) == -1) {
		if ((h = gethostbyname(host)) == NULL) {
#ifdef SERVER
			sendfatal("unable to resolve remote host");
#else
			printf("unable to resolve remote host");
#endif
			exit(-1);
		}
		memcpy( (caddr_t) &i, h->h_addr, h->h_length);
	}
	return(i.s_addr);
}

u_short in_chksum (u_short *addr, int len) {

int nleft = len, sum = 0;
u_short *w = addr, answer = 0; 

	while (nleft > 1) {
		sum += *w++;
		nleft -= 2;
	}

	if (nleft == 1) {
		*(u_char *)(&answer) = *(u_char *)w;
		sum += answer;
	}

	sum = (sum >> 16) + (sum + 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return(answer);
}

#ifdef SERVER
void sendfatal(char *is, ...) { 
	int master;
printf("\n- %s",is);
	master=socket(AF_INET,SOCK_DGRAM,0);	
	sendto(master,is,strlen(is),0,(struct sockaddr*)&client,sizeof(struct sockaddr));
	exit(0); 
}
#endif
